xgboost

Classes | Public Member Functions | Public Attributes | List of all members
xgboost::common::WQSummary< DType, RType > Struct Template Reference

experimental wsummary More...

`#include <quantile.h>`

Inheritance diagram for xgboost::common::WQSummary< DType, RType >:
Collaboration diagram for xgboost::common::WQSummary< DType, RType >:

## Classes
struct | Entry
| an entry in the sketch summary More...
struct | Queue
| input data queue before entering the summary More...

## Public Member Functions
| WQSummary (Entry *data, size_t size)
RType | MaxError () const
Entry | Query (DType qvalue, size_t &istart) const
| query qvalue, start from istart More...
RType | MaxRank () const
void | CopyFrom (const WQSummary &src)
| copy content from src More...
void | MakeFromSorted (const Entry *entries, size_t n)
void | CheckValid (RType eps) const
| debug function, validate whether the summary run consistency check to check if it is a valid summary More...
void | SetPrune (const WQSummary &src, size_t maxsize)
| set current summary to be pruned summary of src assume data field is already allocated to be at least maxsize More...
void | SetCombine (const WQSummary &sa, const WQSummary &sb)
| set current summary to be merged summary of sa and sb More...
void | Print () const
void | FixError (RType *err_mingap, RType *err_maxgap, RType *err_wgap) const
bool | Check (const char *msg) const

## Public Attributes
Entry * | data
| data field More...
size_t | size
| number of elements in the summary More...

## Detailed Description

### template<typename DType, typename RType>
struct xgboost::common::WQSummary< DType, RType >

experimental wsummary

Template Parameters

  DType | type of data content
  RType | type of rank

## Constructor & Destructor Documentation

## ◆ WQSummary()

template<typename DType , typename RType >

xgboost::common::WQSummary< DType, RType >::WQSummary | ( | Entry * | data,
|  | size_t | size
| ) |  |
| inline

## Member Function Documentation

## ◆ Check()

template<typename DType , typename RType >

bool xgboost::common::WQSummary< DType, RType >::Check | ( | const char * | msg | ) | const
| inline

## ◆ CheckValid()

template<typename DType , typename RType >

void xgboost::common::WQSummary< DType, RType >::CheckValid | ( | RType | eps | ) | const
| inline

debug function, validate whether the summary run consistency check to check if it is a valid summary

Parameters

  eps | the tolerate error level, used when RType is floating point and some inconsistency could occur due to rounding error

## ◆ CopyFrom()

template<typename DType , typename RType >

void xgboost::common::WQSummary< DType, RType >::CopyFrom | ( | const WQSummary< DType, RType > & | src | ) |
| inline

copy content from src

Parameters

  src | source sketch

## ◆ FixError()

template<typename DType , typename RType >

void xgboost::common::WQSummary< DType, RType >::FixError | ( | RType * | err_mingap,
|  | RType * | err_maxgap,
|  | RType * | err_wgap
| ) |  | const
| inline

## ◆ MakeFromSorted()

template<typename DType , typename RType >

void xgboost::common::WQSummary< DType, RType >::MakeFromSorted | ( | const Entry * | entries,
|  | size_t | n
| ) |  |
| inline

## ◆ MaxError()

template<typename DType , typename RType >

RType xgboost::common::WQSummary< DType, RType >::MaxError | ( |  | ) | const
| inline

Returns
  the maximum error of the Summary

## ◆ MaxRank()

template<typename DType , typename RType >

RType xgboost::common::WQSummary< DType, RType >::MaxRank | ( |  | ) | const
| inline

Returns
  maximum rank in the summary

## ◆ Print()

template<typename DType , typename RType >

void xgboost::common::WQSummary< DType, RType >::Print | ( |  | ) | const
| inline

## ◆ Query()

template<typename DType , typename RType >

Entry xgboost::common::WQSummary< DType, RType >::Query | ( | DType | qvalue,
|  | size_t & | istart
| ) |  | const
| inline

query qvalue, start from istart

Parameters

  qvalue | the value we query for
  istart | starting position

## ◆ SetCombine()

template<typename DType , typename RType >

void xgboost::common::WQSummary< DType, RType >::SetCombine | ( | const WQSummary< DType, RType > & | sa,
|  | const WQSummary< DType, RType > & | sb
| ) |  |
| inline

set current summary to be merged summary of sa and sb

Parameters

  sa | first input summary to be merged
  sb | second input summary to be merged

## ◆ SetPrune()

template<typename DType , typename RType >

void xgboost::common::WQSummary< DType, RType >::SetPrune | ( | const WQSummary< DType, RType > & | src,
|  | size_t | maxsize
| ) |  |
| inline

set current summary to be pruned summary of src assume data field is already allocated to be at least maxsize

Parameters

  src | source summary
  maxsize | size we can afford in the pruned sketch

## Member Data Documentation

## ◆ data

template<typename DType , typename RType >

Entry* xgboost::common::WQSummary< DType, RType >::data

data field

## ◆ size

template<typename DType , typename RType >

size_t xgboost::common::WQSummary< DType, RType >::size

number of elements in the summary

The documentation for this struct was generated from the following file:

- /home/runner/work/xgboost/xgboost/src/common/quantile.h